aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorSimon Hausmann <simon.hausmann@qt.io>2017-04-18 12:50:34 +0200
committerTony Sarajärvi <tony.sarajarvi@qt.io>2017-04-21 06:22:10 +0000
commitce9181a96433e50fe8b5cc79876eeffa6971c2ce (patch)
treec1266baedc280dda39b32797139f6a57a7cfdd34
parent6b086604c1993de759f3a7c429e71bf68e38d486 (diff)
Improve reliability of automated xcode installation
Instead of downloading a 4+GB archive and uncompressing it in /tmp, let's uncompress the archive via NFS and feed the data straight into cpio. This should be faster and avoids curl's error handling that's happy to abort instead of re-trying. Change-Id: Ifa5d842c50111ccdbd56e795b270ee6433a63adf Reviewed-by: Frederik Gladhorn <frederik.gladhorn@qt.io> Reviewed-by: Tony Sarajärvi <tony.sarajarvi@qt.io>
-rwxr-xr-xcoin/provisioning/common/install_xcode.sh83
-rwxr-xr-xcoin/provisioning/qtci-macos-10.12-x86_64/020-xcode.sh65
-rwxr-xr-xcoin/provisioning/qtci-osx-10.11-x86_64/020-xcode.sh67
3 files changed, 89 insertions, 126 deletions
diff --git a/coin/provisioning/common/install_xcode.sh b/coin/provisioning/common/install_xcode.sh
new file mode 100755
index 00000000..f8336bad
--- /dev/null
+++ b/coin/provisioning/common/install_xcode.sh
@@ -0,0 +1,83 @@
+#!/bin/bash
+
+#############################################################################
+##
+## Copyright (C) 2017 The Qt Company Ltd.
+## Contact: http://www.qt.io/licensing/
+##
+## This file is part of the provisioning scripts of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL21$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see http://www.qt.io/terms-conditions. For further
+## information use the contact form at http://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 2.1 or version 3 as published by the Free
+## Software Foundation and appearing in the file LICENSE.LGPLv21 and
+## LICENSE.LGPLv3 included in the packaging of this file. Please review the
+## following information to ensure the GNU Lesser General Public License
+## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
+## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
+##
+## As a special exception, The Qt Company gives you certain additional
+## rights. These rights are described in The Qt Company LGPL Exception
+## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+# This script installs Xcode
+# Prerequisites: Have Xcode prefetched to local cache as xz compressed.
+# This can be achieved by fetching Xcode_8.xip from Apple Store.
+# Uncompress it with 'xar -xf Xcode_8.xip'
+# Then get https://gist.githubusercontent.com/pudquick/ff412bcb29c9c1fa4b8d/raw/24b25538ea8df8d0634a2a6189aa581ccc6a5b4b/parse_pbzx2.py
+# with which you can run 'python parse_pbzx2.py Content'.
+# This will give you a file called "Content.part00.cpio.xz" that
+# can be renamed to Xcode_8.xz for this script.
+
+
+
+# shellcheck source=../common/try_catch.sh
+source "${BASH_SOURCE%/*}/try_catch.sh"
+
+function InstallXCode()
+{
+ ExceptionCPIO=103
+ ExceptionAcceptLicense=105
+
+ sourceFile=$1
+ version=$2
+
+ try
+ (
+ echo "Uncompressing and installing '$sourceFile'"
+ xzcat < "$sourceFile" | (cd /Applications/ && sudo cpio -vdmi) || throw $ExceptionCPIO
+
+ echo "Accept license"
+ sudo xcodebuild -license accept || throw $ExceptionAcceptLicense
+
+ echo "Xcode = $version" >> ~/versions.txt
+ )
+ catch || {
+ case $ex_code in
+ $ExceptionCPIO)
+ echo "Failed to unarchive .cpio."
+ exit 1;
+ ;;
+ $ExceptionAcceptLicense)
+ echo "Failed to accept license."
+ exit 1;
+ ;;
+
+ esac
+ }
+
+}
+
diff --git a/coin/provisioning/qtci-macos-10.12-x86_64/020-xcode.sh b/coin/provisioning/qtci-macos-10.12-x86_64/020-xcode.sh
index 070ed049..97ce19ba 100755
--- a/coin/provisioning/qtci-macos-10.12-x86_64/020-xcode.sh
+++ b/coin/provisioning/qtci-macos-10.12-x86_64/020-xcode.sh
@@ -45,66 +45,7 @@
# shellcheck source=../common/try_catch.sh
source "${BASH_SOURCE%/*}/../common/try_catch.sh"
-ExceptionDownloadUrl=100
-ExceptionSHA1=101
-ExceptionUnXZ=102
-ExceptionCPIO=103
-ExceptionDelete=104
-ExceptionAcceptLicense=105
+# shellcheck source=../common/install_xcode.sh
+source "${BASH_SOURCE%/*}/../common/install_xcode.sh"
-
-url=http://ci-files01-hki.ci.local/input/mac/macos_10.12_sierra/Xcode_8.2.1.xz
-targetFile=/tmp/Xcode_8.2.1.xz
-expectedSha1=a68e8a4446f77e781b1ce123125263862f2607a3
-
-try
-(
- echo "Downloading Xcode from primary URL '$url'"
- curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url" || throw $ExceptionDownloadUrl
-
- echo "Checking SHA1 on $targetFile"
- echo "$expectedSha1 *$targetFile" | shasum --check || throw $ExceptionSHA1
-
- echo "Uncompressing '$targetFile'"
- xz -d "$targetFile" || throw $ExceptionUnXZ
-
- echo "Unarchiving '${targetFile%.*}'"
- (cd /Applications/ && sudo cpio -dmiI "${targetFile%.*}") || throw $ExceptionCPIO
-
- echo "Deleting '${targetFile%.*}'"
- rm "${targetFile%.*}" || throw $ExceptionDelete
-
- echo "Accept license"
- sudo xcodebuild -license accept || throw $ExceptionAcceptLicense
-
- echo "XCode = 8.2.1" >> ~/versions.txt
-)
-catch || {
- case $ex_code in
- $ExceptionDownloadUrl)
- echo "Failed to download Xcode."
- exit 1;
- ;;
- $ExceptionSHA1)
- echo "Failed to check SHA1."
- exit 1;
- ;;
- $ExceptionUnXZ)
- echo "Failed to uncompress .xz"
- exit 1;
- ;;
- $ExceptionCPIO)
- echo "Failed to unarchive .cpio."
- exit 1;
- ;;
- $ExceptionDelete)
- echo "Failed to delete temporary file."
- exit 1;
- ;;
- $ExceptionAcceptLicense)
- echo "Failed to accept license."
- exit 1;
- ;;
-
- esac
-}
+InstallXCode /net/ci-files01-hki.ci.local/hdd/www/input/mac/macos_10.12_sierra/Xcode_8.2.1.xz 8.2.1
diff --git a/coin/provisioning/qtci-osx-10.11-x86_64/020-xcode.sh b/coin/provisioning/qtci-osx-10.11-x86_64/020-xcode.sh
index 44453e55..7555c752 100755
--- a/coin/provisioning/qtci-osx-10.11-x86_64/020-xcode.sh
+++ b/coin/provisioning/qtci-osx-10.11-x86_64/020-xcode.sh
@@ -47,68 +47,7 @@
# shellcheck source=../common/try_catch.sh
source "${BASH_SOURCE%/*}/../common/try_catch.sh"
-ExceptionDownloadUrl=100
-ExceptionSHA1=101
-ExceptionUnXZ=102
-ExceptionCPIO=103
-ExceptionDelete=104
-ExceptionAcceptLicense=105
-
-
-url=http://ci-files01-hki.ci.local/input/mac/Xcode_8.2.xz
-targetFile=/tmp/Xcode_8.2.xz
-expectedSha1=46edc920955e315d946e36c45f629d5ee9dc9d59
-
-try
-(
- echo "Downloading Xcode from primary URL '$url'"
- curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url" || throw $ExceptionDownloadUrl
-
- echo "Checking SHA1 on $targetFile"
- echo "$expectedSha1 *$targetFile" | shasum --check || throw $ExceptionSHA1
-
- echo "Uncompressing '$targetFile'"
- xz -d "$targetFile" || throw $ExceptionUnXZ
-
- echo "Unarchiving '${targetFile%.*}'"
- (cd /Applications/ && sudo cpio -dmiI "${targetFile%.*}") || throw $ExceptionCPIO
-
- echo "Deleting '${targetFile%.*}'"
- rm "${targetFile%.*}" || throw $ExceptionDelete
-
- echo "Accept license"
- sudo xcodebuild -license accept || throw $ExceptionAcceptLicense
-
- echo "Xcode = 8.2" >> ~/versions.txt
-)
-catch || {
- case $ex_code in
- $ExceptionDownloadUrl)
- echo "Failed to download Xcode."
- exit 1;
- ;;
- $ExceptionSHA1)
- echo "Failed to check SHA1."
- exit 1;
- ;;
- $ExceptionUnXZ)
- echo "Failed to uncompress .xz"
- exit 1;
- ;;
- $ExceptionCPIO)
- echo "Failed to unarchive .cpio."
- exit 1;
- ;;
- $ExceptionDelete)
- echo "Failed to delete temporary file."
- exit 1;
- ;;
- $ExceptionAcceptLicense)
- echo "Failed to accept license."
- exit 1;
- ;;
-
- esac
-}
-
+# shellcheck source=../common/install_xcode.sh
+source "${BASH_SOURCE%/*}/../common/install_xcode.sh"
+InstallXCode /net/ci-files01-hki.ci.local/hdd/www/input/mac/Xcode_8.2.xz 8.2